function [S1,R1,I1,S2,R2,I2]=SIRmodel_2groups_func(T,N1,betap11,betap12,betap21,betap22,gammap1,gammap2,omegap1,omegap2)

%T1 = 50;

%T2 = T1;

%T = T1+T2;

%N1 = 0.1
N2 = 1-N1;

% betap11 = 1.75;      %group-specific transmission coefficient
% betap12 = 1.75;
% betap21 = 1.75;     
% betap22 = 1.75;
% gammap1 = 0.5;     %recovery rate
% gammap2 = gammap1;
% omegap1 = 0;        %death rate
% omegap2 = omegap1;

    
    I1 = zeros(1,T); S1 = zeros(1,T); R1 = zeros(1,T);  
    I2 = zeros(1,T); S2 = zeros(1,T); R2 = zeros(1,T); 

    I1(1) = 1/10000;
    S1(1) = N1-I1(1);
    R1(1) = 0;
    I2(1) = 1/10000;;
    S2(1) = N2-I2(1);
    R2(1) = 0;

%     if i == 2
%         betap12 = 0;
%         betap21 = 0; 
%     end
    
    for t = 2:T
        lambda1(t-1) = betap11*I1(t-1)+betap12*I2(t-1);
        lambda2(t-1) = betap21*I1(t-1)+betap22*I2(t-1);
        S1(t) = S1(t-1) - lambda1(t-1)*S1(t-1);
        I1(t) = I1(t-1) + lambda1(t-1)*S1(t-1)-(gammap1+omegap1)*I1(t-1);
        R1(t) = R1(t-1) + gammap1*I1(t-1);
        S2(t) = S2(t-1) - lambda2(t-1)*S2(t-1);
        I2(t) = I2(t-1) + lambda2(t-1)*S2(t-1)-(gammap2+omegap2)*I2(t-1);
        R2(t) = R2(t-1) + gammap2*I2(t-1);
    end    
 


%% Figure 1
% figure;
% subplot(2,2,1)
% title('Group 1, Homogeneous Mixing between Groups')
% hold on
% plot(1:1:T1,Smat1(1,1:T1),'--g','Linewidth',2);
% plot(1:1:T1,Imat1(1,1:T1),'b','Linewidth',2);
% plot(1:1:T1,Rmat1(1,1:T1),'-.r','Linewidth',2);
% legend('Susceptible','Infective','Removed')
% hold off
% 
% subplot(2,2,2)
% title('Group 2, Homogeneous Mixing between Groups')
% hold on
% plot(1:1:T1,Smat2(1,1:T1),'--g','Linewidth',2);
% plot(1:1:T1,Imat2(1,1:T1),'b','Linewidth',2);
% plot(1:1:T1,Rmat2(1,1:T1),'-.r','Linewidth',2);
% legend('Susceptible','Infective','Removed')
% hold off
% 
% subplot(2,2,3)
% title('Group 1, Insulation of Groups')
% hold on
% plot(1:1:T1,Smat1(2,1:T1),'--g','Linewidth',2);
% plot(1:1:T1,Imat1(2,1:T1),'b','Linewidth',2);
% plot(1:1:T1,Rmat1(2,1:T1),'-.r','Linewidth',2);
% legend('Susceptible','Infective','Removed')
% hold off
% 
% subplot(2,2,4)
% title('Group 2, Insulation of Groups')
% hold on
% plot(1:1:T1,Smat2(2,1:T1),'--g','Linewidth',2);
% plot(1:1:T1,Imat2(2,1:T1),'b','Linewidth',2);
% plot(1:1:T1,Rmat2(2,1:T1),'-.r','Linewidth',2);
% legend('Susceptible','Infective','Removed')
% hold off

%print -depsc SIRmodel_2groups.eps
