function [S1,R1,I1,S2,R2,I2,S3,R3,I3]=SIRmodel_3groups_func(months,...
            months_lockdown,effectiveness_share,share1_lockdown,share2_lockdown,share3_lockdown,...
            N1,N2,betap_base,gammap1,gammap2,gammap3,omegap1,omegap2,omegap3)

%months = 30;
%months_lockdown = 5;
% call SIR model

T = months*30;  %supports at most 30 periods for now -- add lags to go beyond
T_lockdown = months_lockdown*30;

%N1 = 0.25;
%N2 = 0.60;
N3 = 1-N1-N2;

%lockdown parameters (social distancing)
% effectiveness_share = 0.8;
% share1_lockdown = 1;
% share2_lockdown = 0;
% share3_lockdown = 1;

%group-specific transmission coefficient
%betap_base = 0.2;

betap11 = betap_base;
betap12 = betap_base;
betap13 = betap_base;
betap21 = betap_base;
betap22 = betap_base;
betap23 = betap_base;
betap31 = betap_base;
betap32 = betap_base;
betap33 = betap_base;

betap11_lockdown = betap_base*(1-effectiveness_share*share1_lockdown)^2;      
betap12_lockdown = betap_base*(1-effectiveness_share*share1_lockdown)*(1-effectiveness_share*share2_lockdown);
betap13_lockdown = betap_base*(1-effectiveness_share*share1_lockdown)*(1-effectiveness_share*share3_lockdown);;
betap21_lockdown = betap_base*(1-effectiveness_share*share2_lockdown)*(1-effectiveness_share*share1_lockdown);;     
betap22_lockdown = betap_base*(1-effectiveness_share*share2_lockdown)^2;
betap23_lockdown = betap_base*(1-effectiveness_share*share2_lockdown)*(1-effectiveness_share*share3_lockdown);;
betap31_lockdown = betap_base*(1-effectiveness_share*share3_lockdown)*(1-effectiveness_share*share1_lockdown);;     
betap32_lockdown = betap_base*(1-effectiveness_share*share3_lockdown)*(1-effectiveness_share*share2_lockdown);;
betap33_lockdown = betap_base*(1-effectiveness_share*share3_lockdown)^2;

% gammap1 = 1/20;     %recovery rate
% gammap2 = gammap1;
% gammap3 = (1-(0.005/N3))*gammap1;
% omegap1 = 0;        %death rate
% omegap2 = omegap1;
% omegap3 = (0.005/N3)*gammap1;



    
    I1 = zeros(1,T); S1 = zeros(1,T); R1 = zeros(1,T);  
    I2 = zeros(1,T); S2 = zeros(1,T); R2 = zeros(1,T); 
    I3 = zeros(1,T); S3 = zeros(1,T); R3 = zeros(1,T); 

    I1(1) = 1/10000;
    S1(1) = N1-I1(1);
    R1(1) = 0;
    I2(1) = 1/10000;;
    S2(1) = N2-I2(1);
    R2(1) = 0;
    I3(1) = 1/10000;;
    S3(1) = N3-I3(1);
    R3(1) = 0;

   
    
    for t = 2:T
        if t<=T_lockdown
            lambda1(t-1) = betap11_lockdown*I1(t-1)+betap12_lockdown*I2(t-1)+betap13_lockdown*I3(t-1);
            lambda2(t-1) = betap21_lockdown*I1(t-1)+betap22_lockdown*I2(t-1)+betap23_lockdown*I3(t-1);
            lambda3(t-1) = betap31_lockdown*I1(t-1)+betap32_lockdown*I2(t-1)+betap33_lockdown*I3(t-1);
        else
            lambda1(t-1) = 0; %betap11*I1(t-1)+betap12*I2(t-1)+betap13*I3(t-1);
            lambda2(t-1) = 0; %betap21*I1(t-1)+betap22*I2(t-1)+betap23*I3(t-1);
            lambda3(t-1) = 0; %betap31*I1(t-1)+betap32*I2(t-1)+betap33*I3(t-1);
        end
        S1(t) = S1(t-1) - lambda1(t-1)*S1(t-1);
        I1(t) = I1(t-1) + lambda1(t-1)*S1(t-1)-(gammap1+omegap1)*I1(t-1);
        R1(t) = R1(t-1) + gammap1*I1(t-1);
        S2(t) = S2(t-1) - lambda2(t-1)*S2(t-1);
        I2(t) = I2(t-1) + lambda2(t-1)*S2(t-1)-(gammap2+omegap2)*I2(t-1);
        R2(t) = R2(t-1) + gammap2*I2(t-1);
        S3(t) = S3(t-1) - lambda3(t-1)*S3(t-1);
        I3(t) = I3(t-1) + lambda3(t-1)*S3(t-1)-(gammap3+omegap3)*I3(t-1);
        R3(t) = R3(t-1) + gammap3*I3(t-1);
    end    
  

%% Figure 1
% nperiods = 400;
% figure;
% subplot(2,2,1)
% title('Non-working Young')
% hold on
% plot(1:1:nperiods,Smat1(1,1:nperiods),'--g','Linewidth',2);
% plot(1:1:nperiods,Imat1(1,1:nperiods),'b','Linewidth',2);
% plot(1:1:nperiods,Rmat1(1,1:nperiods),'-.r','Linewidth',2);
% legend('Susceptible','Infective','Removed')
% hold off
% 
% subplot(2,2,2)
% title('Working Population')
% hold on
% plot(1:1:nperiods,Smat2(1,1:nperiods),'--g','Linewidth',2);
% plot(1:1:nperiods,Imat2(1,1:nperiods),'b','Linewidth',2);
% plot(1:1:nperiods,Rmat2(1,1:nperiods),'-.r','Linewidth',2);
% legend('Susceptible','Infective','Removed')
% hold off
% 
% subplot(2,2,3)
% title('Non-Working Old')
% hold on
% plot(1:1:nperiods,Smat3(1,1:nperiods),'--g','Linewidth',2);
% plot(1:1:nperiods,Imat3(1,1:nperiods),'b','Linewidth',2);
% plot(1:1:nperiods,Rmat3(1,1:nperiods),'-.r','Linewidth',2);
% legend('Susceptible','Infective','Removed')
% hold off
% 
% subplot(2,2,4)
% title('Total Population')
% hold on
% plot(1:1:nperiods,Smat(1,1:nperiods),'--g','Linewidth',2);
% plot(1:1:nperiods,Imat(1,1:nperiods),'b','Linewidth',2);
% plot(1:1:nperiods,Rmat(1,1:nperiods),'-.r','Linewidth',2);
% legend('Susceptible','Infective','Removed')
% hold off
% 
% %print -depsc SIRmodel_3groups.eps
