
clear
paramfile_two_sector_vcu;



months = 6;
months_lockdown = 0;

effectiveness_share = 0.8;  % irrelevant without a lockdown
share1_lockdown = 0.25;
share2_lockdown = 0.75;
share3_lockdown = share1_lockdown*(l1_ss/(l1_ss+l2_ss))+share2_lockdown*(l2_ss/(l1_ss+l2_ss));


share_working_while_infected = 0.4;

share_working_while_lockdown_1 = 0.15;
share_working_while_lockdown_2 = 0.4;

N1 = l1_ss;
N2 = l2_ss;

% run as daily model
betap_base = 0.2;

gammap1 = 1/20;    % recovery rate
gammap2 = gammap1;
gammap3 = gammap1;

omegap1 = 0;       % death rate -- abstract from the effects of deaths for now
omegap2 = omegap1;
omegap3 = omegap1;

[S1,R1,I1,S2,R2,I2,S3,R3,I3]=SIRmodel_3groups_func(months,...
    months_lockdown,effectiveness_share,share1_lockdown,share2_lockdown,share3_lockdown,...
    N1,N2,betap_base,gammap1,gammap2,gammap3,omegap1,omegap2,omegap3);


S = S1+S2+S3;
R = R1+R2+R3;
I = I1+I2+I3;


figure

nperiods = months*30;
plot(1:1:nperiods,S,'--g','Linewidth',2);hold on
plot(1:1:nperiods,I,'b','Linewidth',2);
plot(1:1:nperiods,R,'-.r','Linewidth',2);
legend('Susceptible','Infective','Removed')
ylabel('Population share')
xlabel('Days')
