clear

setpath_dynare

global M_ oo_ changes_names changes_vec

modnam = 'two_sector_vcu';
modnamstar= 'two_sector_vcu_binding';

modnam_one_sector = 'one_sector_vcu';
modnamstar_one_sector= 'one_sector_vcu_binding';

capital_irreversibility_switch = 1;


constraint = 'in<-in_ss';
constraint_relax = 'lambdai<-0.0000001';

maxiter = 20;

case_switch = 1;  % 1, baseline, 2 cheapest, 3 shift lockdown to outside the labor force, 4 too strict

slide_switch = 1;


eval(['dynare ',modnam,' noclearall'])

for case_switch = 1:7
    paramfile_two_sector_vcu;
    
    
    
    months = 12;
    months_lockdown = 3;
    switch_vaccine = 0;
    
    % run as daily model
    betap_base = 0.2;
    
    if case_switch ==1
        % first case --- let folks who can work from home
        effectiveness_share = 1;  % irrelevant without a lockdown
        share1_lockdown = 0.15;
        share2_lockdown = 0.40;
        share3_lockdown = share1_lockdown*(l1_ss/(l1_ss+l2_ss))+share2_lockdown*(l2_ss/(l1_ss+l2_ss));
        %share3_lockdown = .9;
        months_lockdown = 8;
        
    elseif case_switch == 2
        % keep a few more at home
        effectiveness_share = 1;
        share1_lockdown = 0.18;
        share2_lockdown = 0.45;
        share3_lockdown = share1_lockdown*(l1_ss/(l1_ss+l2_ss))+share2_lockdown*(l2_ss/(l1_ss+l2_ss));
        %share3_lockdown = 0.8;
        
        months = 24;
        months_lockdown = 9;
        
    elseif case_switch == 3
        % Short, too aggressive policy
        effectiveness_share = 1;
        share1_lockdown = 0.40;
        share2_lockdown = 0.9;
        months_lockdown = 3;
        share3_lockdown = 1;
        
    elseif case_switch == 4
        % waiting for a vaccine
        switch_vaccine = 1;
        share1_lockdown = 0.25;
        share2_lockdown = 0.6;
        share3_lockdown = share1_lockdown*(l1_ss/(l1_ss+l2_ss))+share2_lockdown*(l2_ss/(l1_ss+l2_ss));
        
        %share3_lockdown = .8;
        effectiveness_share = 1;
        months = 30;
        months_lockdown = 18;
        
        
    elseif case_switch == 5
        % sensitivity to waiting for a vaccine, lower effectiveness
        switch_vaccine = 1;
        share1_lockdown = 0.32;
        share2_lockdown = 0.75;
        share3_lockdown = share1_lockdown*(l1_ss/(l1_ss+l2_ss))+share2_lockdown*(l2_ss/(l1_ss+l2_ss));
        
        %share3_lockdown = .8;
        effectiveness_share = 0.8;
        months = 30;
        months_lockdown = 18;
        
    elseif case_switch == 6
        % sensitivity to waiting for a vaccine, higher share of group 3 under
        % lockdown
        switch_vaccine = 1;
        share1_lockdown = 0.17;
        share2_lockdown = 0.44;
        %share3_lockdown = share1_lockdown*(l1_ss/(l1_ss+l2_ss))+share2_lockdown*(l2_ss/(l1_ss+l2_ss));
        
        share3_lockdown = .8;
        effectiveness_share = 1;
        months = 30;
        months_lockdown = 18;
        
    elseif case_switch == 7
        % This is the case for R_0 = 2 mentioned at the end of the Discussion
        % section.
        switch_vaccine = 1;
        share1_lockdown = 0.15;
        share2_lockdown = 0.40;
        share3_lockdown = share1_lockdown*(l1_ss/(l1_ss+l2_ss))+share2_lockdown*(l2_ss/(l1_ss+l2_ss));
        
        %share3_lockdown = .8;
        effectiveness_share = 1;
        months = 30;
        months_lockdown = 16;
        betap_base = 0.1;
        
    end
    
    
    
    share_working_while_infected = 0.4;
    
    share_working_while_lockdown_1 = 0.15;
    share_working_while_lockdown_2 = 0.4;
    
    N1 = l1_ss;
    N2 = l2_ss;
    
    
    
    gammap1 = 1/20;    % recovery rate
    gammap2 = gammap1;
    gammap3 = gammap1;
    
    omegap1 = 0;       % death rate -- abstract from the effects of deaths for now
    omegap2 = omegap1;
    omegap3 = omegap1;
    
    
    if switch_vaccine == 0
        [S1_lockdown,R1_lockdown,I1_lockdown,S2_lockdown,R2_lockdown,I2_lockdown,S3_lockdown,R3_lockdown,I3_lockdown]=SIRmodel_3groups_func(months,...
            months_lockdown,effectiveness_share,share1_lockdown,share2_lockdown,share3_lockdown,...
            N1,N2,betap_base,gammap1,gammap2,gammap3,omegap1,omegap2,omegap3);
    else
        [S1_lockdown,R1_lockdown,I1_lockdown,S2_lockdown,R2_lockdown,I2_lockdown,S3_lockdown,R3_lockdown,I3_lockdown]=SIRmodel_3groups_vaccine_func(months,...
            months_lockdown,effectiveness_share,share1_lockdown,share2_lockdown,share3_lockdown,...
            N1,N2,betap_base,gammap1,gammap2,gammap3,omegap1,omegap2,omegap3);
    end
    % temporal aggregation of SIR model from days to months
    I1_lockdown_month = mean(reshape(I1_lockdown',30,months));
    I2_lockdown_month = mean(reshape(I2_lockdown',30,months));
    
    
    % path for the exogenous variable
    paramfile_two_sector_vcu
    
    % take off the infected folks from the labor force
    
    path_lockdown = [ones(months_lockdown,1); zeros(months-months_lockdown,1)];
    
    l1_path = path_lockdown.*(-max(share1_lockdown-share_working_while_lockdown_1,0)*N1...
        -min(share1_lockdown,share_working_while_lockdown_1)*(1-share_working_while_infected)*I1_lockdown_month'...
        -(1-share1_lockdown)*(1-share_working_while_infected)*I1_lockdown_month')...
        +(1-path_lockdown).*(-(1-share_working_while_infected)*I1_lockdown_month');
    
    l2_path = path_lockdown.*(-max(share2_lockdown-share_working_while_lockdown_2,0)*N2...
        -min(share2_lockdown,share_working_while_lockdown_2)*(1-share_working_while_infected)*I2_lockdown_month'...
        -(1-share2_lockdown)*(1-share_working_while_infected)*I2_lockdown_month')...
        +(1-path_lockdown).*(-(1-share_working_while_infected)*I2_lockdown_month');
    
    l1_path_martin =  - I1_lockdown_month'*(1-share_working_while_infected)-(share1_lockdown-share_working_while_lockdown_1)*(N1-(1-share_working_while_infected)*I1_lockdown_month').*path_lockdown;
    l2_path_martin =  - I2_lockdown_month'*(1-share_working_while_infected)-(share2_lockdown-share_working_while_lockdown_2)*(N2-(1-share_working_while_infected)*I2_lockdown_month').*path_lockdown;
    
    
    l1_path_lag = [0; l1_path(1:end-1)];
    l2_path_lag = [0; l2_path(1:end-1)];
    
    % define matrix needed to calculate the sizes of the shocks
    amat = diag(rhop_l*ones(months,1));
    
    % translate the path for a into the path for the shocks m
    m_path = l1_path-amat*l1_path_lag;
    n_path = l2_path-amat*l2_path_lag;
    
    % put the shocks on the vector of predetermined conditions
    m_pos_vec = zeros(months,1);
    n_pos_vec = zeros(months,1);
    
    endo_names = cellstr(M_.endo_names);
    for m_indx = 1:months
        this_m = ['m',num2str(m_indx)];
        this_n = ['n',num2str(m_indx)];
        m_pos_vec(m_indx)=find(strcmp(this_m, endo_names));
        n_pos_vec(m_indx)=find(strcmp(this_n, endo_names));
        
    end
    
    init = zeros(M_.endo_nbr,1);
    init(m_pos_vec)=m_path;
    init(n_pos_vec)=n_path;
    
    % now get the response to the initial conditions
    shockssequence = 0;
    irfshock = '';
    nperiods = months;
    
    changes_names = char('rhop');
    changes_vec =       [-3/2];
    
    if capital_irreversibility_switch
        
        [zdatalinear, zdatapiecewise, zdatass, oobase_ Mbase_] = ...
            solve_one_constraint(modnam,modnamstar,...
            constraint, constraint_relax,...
            shockssequence,irfshock,nperiods,maxiter,init)
        
        zdatalinear = zdatapiecewise;
        
    else
        
        [zdatalinear, zdatass, oobase_, Mbase_ ] = ...
            solve_no_constraint(modnam,...
            shockssequence,irfshock,nperiods,init);
    end
    
    
    %% without social distancing
    
    months_lockdown = 0;
    
    [S1,R1,I1,S2,R2,I2,S3,R3,I3]=SIRmodel_3groups_func(months,...
        months_lockdown,effectiveness_share,share1_lockdown,share2_lockdown,share3_lockdown,...
        N1,N2,betap_base,gammap1,gammap2,gammap3,omegap1,omegap2,omegap3);
    
    %[S1,R1,I1,S2,R2,I2]=SIRmodel_2groups_func(T,N1,betap11,betap12,betap21,betap22,gammap1,gammap2,omegap1,omegap2);
    
    % temporal aggregation of SIR model from days to month
    
    
    I1_month = mean(reshape(I1',30,months));
    I2_month = mean(reshape(I2',30,months));
    
    
    
    
    % path for the exogenous variable
    paramfile_two_sector_vcu
    
    % take off the infected folks from the labor force
    l1_path =  - I1_month'*(1-share_working_while_infected);
    l2_path =  - I2_month'*(1-share_working_while_infected);
    
    l1_path_lag = [0; l1_path(1:end-1)];
    l2_path_lag = [0; l2_path(1:end-1)];
    
    % define matrix needed to calculate the sizes of the shocks
    amat = diag(rhop_l*ones(months,1));
    
    % translate the path for a into the path for the shocks m
    m_path = l1_path-amat*l1_path_lag;
    n_path = l2_path-amat*l2_path_lag;
    
    
    % put the shocks on the vector of predetermined conditions
    m_pos_vec = zeros(months,1);
    n_pos_vec = zeros(months,1);
    
    endo_names = cellstr(M_.endo_names);
    for m_indx = 1:months
        this_m = ['m',num2str(m_indx)];
        this_n = ['n',num2str(m_indx)];
        m_pos_vec(m_indx)=find(strcmp(this_m, endo_names));
        n_pos_vec(m_indx)=find(strcmp(this_n, endo_names));
        
    end
    
    init = zeros(M_.endo_nbr,1);
    init(m_pos_vec)=m_path;
    init(n_pos_vec)=n_path;
    
    
    
    
    if capital_irreversibility_switch
        
        [zdatalinear2, zdatapiecewise2, zdatass2, oobase2_ Mbase2_] = ...
            solve_one_constraint(modnam,modnamstar,...
            constraint, constraint_relax,...
            shockssequence,irfshock,nperiods,maxiter,init)
        
        zdatalinear2 = zdatapiecewise2;
        
    else
        
        [zdatalinear2, zdatass2, oobase2_, Mbase2_ ] = ...
            solve_no_constraint(modnam,...
            shockssequence,irfshock,nperiods,init);
    end
    
    
    
    
    prefix1 = 's1_';
    prefix2 = 's2_';
    for this_var = 1:Mbase_.endo_nbr
        eval([prefix1,deblank(Mbase_.endo_names(this_var,:)),'_irf=zdatalinear(:,this_var);'])
        eval([prefix1,deblank(Mbase_.endo_names(this_var,:)),'_ss=zdatass(this_var);'])
    end
    
    for this_var = 1:Mbase2_.endo_nbr
        eval([prefix2,deblank(Mbase2_.endo_names(this_var,:)),'_irf=zdatalinear2(:,this_var);'])
        eval([prefix2,deblank(Mbase2_.endo_names(this_var,:)),'_ss=zdatass2(this_var);'])
    end
    
    
    
    
    if slide_switch
        
        
        %% Aggregate figure
        titlelist = char(...
            'Output, Total','Capacity Utilization',...
            'Consumption','Investment');
        
        
        line1 = 100*[ ...
            s1_y_irf/s1_y_ss, s1_u_irf/s1_u_ss,...
            s1_c_irf/s1_c_ss, s1_in_irf/s1_in_ss];
        
        line2 = 100*[...
            s2_y_irf/s2_y_ss, s2_u_irf/s2_u_ss,...
            s2_c_irf/s2_c_ss, s2_in_irf/s2_in_ss];
        
        percent = '% dev. from steady state';
        ppt = 'Perc. Point';
        level = 'Level';
        percent_group = '% of group size';
        
        ylabels = char(...
            percent,percent,...
            percent,percent);
        figlabel = '';
        legendlist = char('Do Nothing','Social Distancing');
        makechart(titlelist,legendlist,figlabel,ylabels,line2,line1);
        subplot(2,2,3)
        xlabel('Months')
        subplot(2,2,4)
        xlabel('Months')
        
        
        printpref_slide
        
        
        %% sectoral detail
        
        titlelist = char(...
            'Labor, Sector 1', 'Labor, Sector 2',...
            'Value Added, Sector 1', 'Value Added, Sector 2');
        
        
        line1 = 100*[ ...
            s1_l1_irf/s1_l1_ss, s1_l2_irf/s1_l2_ss,...
            s1_v1_irf/s1_v1_ss, s1_v2_irf/s1_v2_ss...
            ];
        
        line2 = 100*[...
            s2_l1_irf/s2_l1_ss, s2_l2_irf/s2_l2_ss,...
            s2_v1_irf/s2_v1_ss, s2_v2_irf/s2_v2_ss...
            ];
        
        
        ylabels = char(percent_group,percent_group,...
            percent,percent,...
            percent,percent);
        figlabel = '';
        legendlist = char('Do Nothing','Social Distancing');
        makechart(titlelist,legendlist,figlabel,ylabels,line2,line1);
        subplot(2,2,3)
        xlabel('Months')
        subplot(2,2,4)
        xlabel('Months')
        
        printpref_slide
        
        
    else % slides for paper
        
        %% Aggregate figure
        titlelist = char('Group-1 Infected','Group-2 Infected',...
            'Output, Total','Capacity Utilization',...
            'Consumption','Investment');
        
        
        line1 = 100*[ I1_lockdown_month'/s1_l1_ss, I2_lockdown_month'/s2_l2_ss, ...
            s1_y_irf/s1_y_ss, s1_u_irf/s1_u_ss,...
            s1_c_irf/s1_c_ss, s1_in_irf/s1_in_ss];
        
        line2 = 100*[ I1_month'/s2_l1_ss, I2_month'/s2_l2_ss,...
            s2_y_irf/s2_y_ss, s2_u_irf/s2_u_ss,...
            s2_c_irf/s2_c_ss, s2_in_irf/s2_in_ss];
        
        percent = '% dev. from steady state';
        ppt = 'Perc. Point';
        level = 'Level';
        percent_group = '% of group size';
        
        ylabels = char(percent_group,percent_group,...
            percent,percent,...
            percent,percent);
        figlabel = '';
        legendlist = char('Do Nothing','Social Distancing');
        makechart(titlelist,legendlist,figlabel,ylabels,line2,line1);
        subplot(3,2,5)
        xlabel('Months')
        subplot(3,2,6)
        xlabel('Months')
        
        
        printpref
        
        eval(['print -depsc2 figure1_social_distancing_vs_do_nothing_case',num2str(case_switch),'.eps'])
        
        %% sectoral detail
        
        titlelist = char('Group-1 Infected','Group-2 Infected',...
            'Labor, Sector 1', 'Labor, Sector 2',...
            'Value Added, Sector 1', 'Value Added, Sector 2');
        
        
        line1 = 100*[ I1_lockdown_month'/s1_l1_ss, I2_lockdown_month'/s1_l2_ss, ...
            s1_l1_irf/s1_l1_ss, s1_l2_irf/s1_l2_ss,...
            s1_v1_irf/s1_v1_ss, s1_v2_irf/s1_v2_ss...
            ];
        
        line2 = 100*[ I1_month'/s2_l1_ss, I2_month'/s2_l2_ss, ...
            s2_l1_irf/s2_l1_ss, s2_l2_irf/s2_l2_ss,...
            s2_v1_irf/s2_v1_ss, s2_v2_irf/s2_v2_ss...
            ];
        
        
        ylabels = char(percent_group,percent_group,...
            percent,percent,...
            percent,percent);
        figlabel = '';
        legendlist = char('Do Nothing','Social Distancing');
        makechart(titlelist,legendlist,figlabel,ylabels,line2,line1);
        subplot(3,2,5)
        xlabel('Months')
        subplot(3,2,6)
        xlabel('Months')
        
        printpref
        eval(['print -depsc2 figure2_social_distancing_vs_do_nothing_case',num2str(case_switch),'.eps'])
        
    end
end



%%

if slide_switch
    figure
    
    nperiods = months*30;
    
    subplot(2,2,1)
    S = S1+S2+S3;
    I = I1+I2+I3;
    R = R1+R2+R3;
    
    plot(1:1:nperiods,S,'--g','Linewidth',2);hold on
    plot(1:1:nperiods,I,'b','Linewidth',2);
    plot(1:1:nperiods,R,'-.r','Linewidth',2);
    xlim([1 nperiods])
    legend('Susceptible','Infective','Removed')
    ylabel('Population share')
    xlabel('Days')
    
    grid on
    title('No Social Distancing, Aggregate Population Outcomes')
    
    
    subplot(2,2,2)
    S_lockdown = S1_lockdown+S2_lockdown+S3_lockdown;
    I_lockdown = I1_lockdown+I2_lockdown+I3_lockdown;
    R_lockdown = R1_lockdown+R2_lockdown+R3_lockdown;
    
    plot(1:1:nperiods,S_lockdown,'--g','Linewidth',2);hold on
    plot(1:1:nperiods,I_lockdown,'b','Linewidth',2);
    plot(1:1:nperiods,R_lockdown,'-.r','Linewidth',2);
    xlim([1 nperiods])
    grid on
    
    
    ylabel('Population share')
    xlabel('Days')
    
    title('Social Distancing, Aggregate Population Outcomes')
    
    subplot(2,2,3)
    
    plot(1:1:nperiods,S1_lockdown/l1_ss,'--g','Linewidth',2);hold on
    plot(1:1:nperiods,I1_lockdown/l1_ss,'b','Linewidth',2);
    plot(1:1:nperiods,R1_lockdown/l1_ss,'-.r','Linewidth',2);
    xlim([1 nperiods])
    grid on
    
    
    ylabel('Group 1 share')
    xlabel('Days')
    
    title('Social Distancing, Group-1 Outcomes')
    
    subplot(2,2,4)
    
    plot(1:1:nperiods,S2_lockdown/l2_ss,'--g','Linewidth',2);hold on
    plot(1:1:nperiods,I2_lockdown/l2_ss,'b','Linewidth',2);
    plot(1:1:nperiods,R2_lockdown/l2_ss,'-.r','Linewidth',2);
    xlim([1 nperiods])
    grid on
    
    
    ylabel('Group 2 share')
    xlabel('Days')
    
    title('Social Distancing, Group-2 Outcomes')
    
    
    printpref_slide
    print -depsc2 figure_social_distancing_3groupSIR.eps
    
else
    figure
    
    nperiods = months*30;
    
    subplot(5,1,1)
    S = S1+S2+S3;
    I = I1+I2+I3;
    R = R1+R2+R3;
    
    plot(1:1:nperiods,S,'--g','Linewidth',2);hold on
    plot(1:1:nperiods,I,'b','Linewidth',2);
    plot(1:1:nperiods,R,'-.r','Linewidth',2);
    xlim([1 nperiods])
    legend('Susceptible','Infective','Removed')
    ylabel('Population share')
    xlabel('Days')
    
    grid on
    title('No Social Distancing, Aggregate Population Outcomes')
    
    
    subplot(5,1,2)
    S_lockdown = S1_lockdown+S2_lockdown+S3_lockdown;
    I_lockdown = I1_lockdown+I2_lockdown+I3_lockdown;
    R_lockdown = R1_lockdown+R2_lockdown+R3_lockdown;
    
    plot(1:1:nperiods,S_lockdown,'--g','Linewidth',2);hold on
    plot(1:1:nperiods,I_lockdown,'b','Linewidth',2);
    plot(1:1:nperiods,R_lockdown,'-.r','Linewidth',2);
    xlim([1 nperiods])
    grid on
    
    
    ylabel('Population share')
    xlabel('Days')
    
    title('Social Distancing, Aggregate Population Outcomes')
    
    subplot(5,1,3)
    
    plot(1:1:nperiods,S1_lockdown/l1_ss,'--g','Linewidth',2);hold on
    plot(1:1:nperiods,I1_lockdown/l1_ss,'b','Linewidth',2);
    plot(1:1:nperiods,R1_lockdown/l1_ss,'-.r','Linewidth',2);
    xlim([1 nperiods])
    grid on
    
    
    ylabel('Group 1 share')
    xlabel('Days')
    
    title('Social Distancing, Group-1 Outcomes')
    
    subplot(5,1,4)
    
    plot(1:1:nperiods,S2_lockdown/l2_ss,'--g','Linewidth',2);hold on
    plot(1:1:nperiods,I2_lockdown/l2_ss,'b','Linewidth',2);
    plot(1:1:nperiods,R2_lockdown/l2_ss,'-.r','Linewidth',2);
    xlim([1 nperiods])
    grid on
    
    
    ylabel('Group 2 share')
    xlabel('Days')
    
    title('Social Distancing, Group-2 Outcomes')
    subplot(5,1,5)
    l3_ss = (1-l2_ss-l1_ss);
    
    plot(1:1:nperiods,S3_lockdown/l3_ss,'--g','Linewidth',2);hold on
    plot(1:1:nperiods,I3_lockdown/l3_ss,'b','Linewidth',2);
    plot(1:1:nperiods,R3_lockdown/l3_ss,'-.r','Linewidth',2);
    
    xlim([1 nperiods])
    grid on
    
    
    ylabel('Group 3 share')
    xlabel('Days')
    
    title('Social Distancing, Group-3 Outcomes')
    
    printpref
    print -depsc2 figure_social_distancing_3groupSIR.eps
    
end